
# issueToDate.py
# Andrew Davison, March 2025, ad@coe.psu.ac.th

'''
> python issueToDate.py
Enter an issue number: 158
Issue on 17 Mar 1973, no. 156
The issue appeared on: 31 Mar 1973

> python issueToDate.py
Enter an issue number: 500
Out of range (1-258)
'''

from datetime import datetime, timedelta

issueDates = [   # day 3-letter-month year
  ("28 Mar 1970", 1),
  ("2 Jan 1971", 41), ("18 Sep 1971", 78),
  ("18 Mar 1972", 104), ("16 Sep 1972", 130),
  ("17 Mar 1973", 156), ("15 Sep 1973", 182),
  ("16 Mar 1974", 208), ("14 Sep 1974", 234)
]

LAST_ISSUE = ("1 Mar 1975", 258)
lastDate = datetime.strptime(LAST_ISSUE[0], "%d %b %Y")


def getStartDate(issueNo):
  # find largest date smaller than the user issue
  for dateStr, issue in reversed(issueDates):
    if issue <= issueNo:
      print(f"Issue on {dateStr}, no. {issue}")
      return dateStr, issue



# ---------------------------

issueNo = int(input("Enter an issue number: "))

if (issueNo < 1) or (issueNo > LAST_ISSUE[1]):
  print(f"Out of range (1-{LAST_ISSUE[1]})")
else:
  dateStr, startIssue = getStartDate(issueNo)
  issueDate = datetime.strptime(dateStr, "%d %b %Y") + \
                       (issueNo-startIssue)*timedelta(days=7)
  print("The issue appeared on:", issueDate.strftime('%#d %b %Y')) 
                                       # Windows specific use of #

